"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var IEntityTreeDriver = function () {
  /*
    @param {*} tree
    @param {Array<Object<path: Array, entity *>>} entityMap
    @param {boolean} shouldConstructTree
  */

  function IEntityTreeDriver(tree) {
    var entityMap = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];
    var shouldConstructTree = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

    _classCallCheck(this, IEntityTreeDriver);

    this._tree = tree;
    this._entityMap = entityMap;
    this._shouldConstructTree = shouldConstructTree;
  }

  /*
    @param {Object<path: Array, entity: *>} entitySchema
    @return {Array}
  */


  _createClass(IEntityTreeDriver, [{
    key: "addEntityToTree",
    value: function addEntityToTree(entitySchema) {
      return this._entityMap.push(entitySchema);
    }

    /*
      @param {Array} array
      @return {*} desired array-like structure
    */

  }, {
    key: "asArray",
    value: function asArray(array) {
      return array;
    }

    /*
      @return {*}
    */

  }, {
    key: "getTree",
    value: function getTree() {
      return this._tree;
    }

    /*
      @return Array
    */

  }, {
    key: "getEntityMap",
    value: function getEntityMap() {
      return this._entityMap;
    }

    /*
      @param {Array} path
      @return {*}
    */

  }, {
    key: "getInPath",
    value: function getInPath(path) {
      throw new Error("\n      getInPath() not implemented in " + this.constructor + "\n    ");

      return this._tree;
    }

    /*
      @param {Array} path
      @param {Object} newValue
      @return {*}
    */

  }, {
    key: "updateInPath",
    value: function updateInPath(path, newValue) {
      throw new Error("\n      updateInPath() not implemented in " + this.constructor + "\n    ");

      return this._tree;
    }

    /*
      @param {Array} path
      @return {*}
    */

  }, {
    key: "deleteInPath",
    value: function deleteInPath(path) {
      throw new Error("\n      deleteInPath() not implemented in " + this.constructor + "\n    ");

      return this._tree;
    }

    /*
      @param {Array} path
      @param {Object} entity
      @return {*}
    */

  }, {
    key: "addInPath",
    value: function addInPath(path, entity) {
      throw new Error("\n      addInPath() not implemented in " + this.constructor + "\n    ");

      return this._tree;
    }
  }]);

  return IEntityTreeDriver;
}();

exports.default = IEntityTreeDriver;
module.exports = exports["default"];