'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _ientityTreeDriver = require('./ientity-tree-driver');

var _ientityTreeDriver2 = _interopRequireDefault(_ientityTreeDriver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ImmutableTreeDriver = function (_IEntityTreeDriver) {
  _inherits(ImmutableTreeDriver, _IEntityTreeDriver);

  function ImmutableTreeDriver(tree, entityMap) {
    var shouldConstructTree = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

    _classCallCheck(this, ImmutableTreeDriver);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ImmutableTreeDriver).call(this, tree, entityMap, shouldConstructTree));

    if (shouldConstructTree) {
      _this._tree = _this._constructTreeFromMap(entityMap);
    }
    return _this;
  }

  _createClass(ImmutableTreeDriver, [{
    key: '_constructTreeFromMap',
    value: function _constructTreeFromMap(entityMap) {
      var _this2 = this;

      var tree = null;
      Object.keys(entityMap).forEach(function (tableName) {
        entityMap[tableName].forEach(function (_ref) {
          var path = _ref.path;
          var entity = _ref.entity;

          _this2._tree = _this2._tree.updateIn(path, function () {
            return entity;
          });
        });
      });

      return this._tree;
    }
  }, {
    key: 'getTree',
    value: function getTree() {
      return this._tree;
    }
  }, {
    key: 'getInPath',
    value: function getInPath(path) {
      return this._tree.getIn(path);
    }
  }, {
    key: 'updateInPath',
    value: function updateInPath(path, value) {
      if (typeof value !== 'function') {
        this._tree = this._tree.updateIn(path, function () {
          return value;
        });
      } else {
        this._tree = this._tree.updateIn(path, value);
      }

      return this._tree;
    }
  }, {
    key: 'deleteInPath',
    value: function deleteInPath(path) {
      this._tree = this._tree.deleteIn(path);
      return this._tree;
    }
  }, {
    key: 'addInPath',
    value: function addInPath(path, entity) {
      var entities = this.getInPath(path);
      this._tree = this.updateInPath(path, entities.concat([entity]));
      return this._tree;
    }
  }, {
    key: 'asArray',
    value: function asArray(array) {
      return _immutable2.default.List(array);
    }
  }]);

  return ImmutableTreeDriver;
}(_ientityTreeDriver2.default);

exports.default = function (tree, entityMap) {
  var shouldConstructTree = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  return new ImmutableTreeDriver(tree, entityMap, shouldConstructTree);
};

module.exports = exports['default'];