'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.recreateStructure = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _ientityTreeDriver = require('./ientity-tree-driver');

var _ientityTreeDriver2 = _interopRequireDefault(_ientityTreeDriver);

var _objectUtils = require('../utils/object-utils');

var objectUtils = _interopRequireWildcard(_objectUtils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var recreateStructure = exports.recreateStructure = function recreateStructure(objectOrArray) {
  if (Array.isArray(objectOrArray)) {
    return objectOrArray.slice();
  }

  if (objectUtils.isObject(objectOrArray)) {
    return _extends({}, objectOrArray);
  }
};

var ObjectImmutableDriver = function (_IEntityTreeDriver) {
  _inherits(ObjectImmutableDriver, _IEntityTreeDriver);

  function ObjectImmutableDriver(tree) {
    _classCallCheck(this, ObjectImmutableDriver);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(ObjectImmutableDriver).call(this, tree));
  }

  _createClass(ObjectImmutableDriver, [{
    key: 'getTree',
    value: function getTree() {
      return this._tree;
    }
  }, {
    key: '_getInPathRaw',
    value: function _getInPathRaw(path) {
      try {
        return objectUtils.getInPath(this._tree, path);
      } catch (err) {
        return undefined;
      }
    }
  }, {
    key: 'getInPath',
    value: function getInPath(path) {
      var value = this._getInPathRaw(path);
      return value === undefined ? null : value;
    }
  }, {
    key: '_walkPathInTree',
    value: function _walkPathInTree(path, targetValue) {
      var counter = 0;
      var tree = _extends({}, this._tree);

      path.reduce(function (tree, key) {
        counter++;
        tree[key] = recreateStructure(tree[key]);

        if (path.length === counter) {
          var nextSubValue = typeof targetValue === 'function' ? targetValue(tree[key], tree, key) : targetValue;
          if (nextSubValue === undefined) {
            if (Array.isArray(tree)) {
              tree.splice(key, String(key) === '0' ? 1 : key);
            } else {
              delete tree[key];
            }
          } else {
            tree[key] = nextSubValue;
          }
        }

        return tree[key];
      }, tree);

      return tree;
    }
  }, {
    key: 'updateInPath',
    value: function updateInPath(path, value) {
      var prevValue = this.getInPath(path);
      if (prevValue === value) {
        return this._tree;
      }

      this._tree = this._walkPathInTree(path, value);
      return this._tree;
    }
  }, {
    key: 'deleteInPath',
    value: function deleteInPath(path) {
      if (this._getInPathRaw(path) === undefined) {
        return this._tree;
      }

      this._tree = this._walkPathInTree(path, undefined);
      return this._tree;
    }
  }, {
    key: 'addInPath',
    value: function addInPath(path, entity) {
      var entities = this.getInPath(path) || [];
      objectUtils.ensurePathInObject(this._tree, path);
      this._tree = this.updateInPath(path, entities.concat([entity]));

      return this._tree;
    }
  }]);

  return ObjectImmutableDriver;
}(_ientityTreeDriver2.default);

exports.default = function (tree, entityMap) {
  var shouldCreateTree = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  return new ObjectImmutableDriver(tree, entityMap, shouldCreateTree);
};