'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMapper;

var _treeIndexedMapper = require('./tree-indexed-mapper');

var _treeIndexedMapper2 = _interopRequireDefault(_treeIndexedMapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createMapper(driver) {
  var indexKeys = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];
  var tables = arguments.length <= 2 || arguments[2] === undefined ? null : arguments[2];
  var primaryKey = arguments.length <= 3 || arguments[3] === undefined ? 'id' : arguments[3];

  if (!indexKeys.some(function (candidate) {
    return candidate === primaryKey;
  })) {
    indexKeys.push(primaryKey);
  }

  var tree = driver.getTree();
  var entityMap = driver.getEntityMap();
  tables = tables || Object.keys(tree);

  var indexes = !entityMap ? (0, _treeIndexedMapper.mapObject)(tree, tables, indexKeys, primaryKey) : (0, _treeIndexedMapper.entityMapToIndexes)(entityMap, tables, indexKeys, primaryKey);

  return new _treeIndexedMapper2.default(driver, indexes, indexKeys, primaryKey);
}
module.exports = exports['default'];