"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var ensurePathInObject = exports.ensurePathInObject = function ensurePathInObject(object, path, defaultValue) {
  var counter = 0;
  path.reduce(function (object, key) {
    counter++;
    if (object[key] !== undefined) {
      return object[key];
    }

    if (path.length !== counter) {
      object[key] = {};
    } else {
      object[key] = defaultValue;
    }

    return object[key];
  }, object);
  return object;
};

var deleteInPath = exports.deleteInPath = function deleteInPath(object, path) {
  var parentObject = getInPath(object, path.slice(0, path.length - 1));
  var last = path.pop();
  delete parentObject[last];

  return object;
};

var getInPath = exports.getInPath = function getInPath(object, path) {
  return path.reduce(function (object, key) {
    return object[key];
  }, object);
};

var isObject = exports.isObject = function isObject(value) {
  return value === Object(value);
};